#include <wchar.h>
#include <unistd.h>
#include "zaznam.h"
#include "../gdbm-local.h"
#include "../struktury_dbm.h"
#include "../curses.h"
#include "../struktury.h"
#include "../lib.h"
#include "../lib_dbm.h"

#define HORZ '$'
#define VERT '#'

void zaznam_novy(DBM * dbm_ptr)
{
    WINDOW *sub_win;
    struct zaznam predmet;

    sub_win = subwin(stdscr, LINES, COLS, 0, 0);

  znovu:
    wclear(sub_win);
    box(sub_win, HORZ, VERT);
    echo();

    wattron(sub_win, COLOR_PAIR(CERVENA));
    mvwprintw8(sub_win, 5, 4, L"%-27s", "Zadejte KÓD předmětu: ");
    wattroff(sub_win, COLOR_PAIR(CERVENA));
    wrefresh(sub_win);
    wgetn_wstr(sub_win, (wint_t *) predmet.kod,
	       sizeof(predmet.kod) / sizeof(predmet.kod[0]) - 1);

    if (!wcscmp(predmet.kod, L"")) {
	wprintw(sub_win, "\n\tZadali jste prázdný kód!");
	wrefresh(sub_win);
	sleep(2);
	delwin(sub_win);
	return;
    }

    velka_pismena(predmet.kod);

    wattron(sub_win, COLOR_PAIR(CERVENA));
    mvwprintw8(sub_win, 6, 4, L"%-27s", "Zadejte NÁZEV předmětu: ");
    wattroff(sub_win, COLOR_PAIR(CERVENA));
    wrefresh(sub_win);
    wgetn_wstr(sub_win, (wint_t *) predmet.nazev,
	       sizeof(predmet.nazev) / sizeof(predmet.nazev[0]) - 1);

    if (!wcscmp(predmet.nazev, L"")) {
	wprintw(sub_win, "\n\tNezadali jste název předmětu!");
	wrefresh(sub_win);
	sleep(2);
	delwin(sub_win);
	return;
    }


    do {
	wattron(sub_win, COLOR_PAIR(CERVENA));
	mvwprintw8(sub_win, 7, 4, L"%-27s", "Počet KREDITů: ");
	wattroff(sub_win, COLOR_PAIR(CERVENA));
	wclrtoeol(sub_win);
	box(sub_win, HORZ, VERT);
	wrefresh(sub_win);
	if (0 >= wscanw(sub_win, "%i", &predmet.kreditu)) {
	    predmet.kreditu = -1;
	}
    }
    while (predmet.kreditu < 0 || predmet.kreditu > 100);


    do {
	wattron(sub_win, COLOR_PAIR(CERVENA));
	mvwprintw8(sub_win, 8, 4, L"%-27s",
		   "ZNÁMKA (0 = neznámkováno): ");
	wattroff(sub_win, COLOR_PAIR(CERVENA));
	wclrtoeol(sub_win);
	box(sub_win, HORZ, VERT);
	wrefresh(sub_win);
	if (0 >= wscanw(sub_win, "%i", &predmet.znamka)) {
	    predmet.znamka = -1;
	}
    }
    while ((predmet.znamka < 0 || predmet.znamka > 3));


    do {
	wattron(sub_win, COLOR_PAIR(SVETLEM));
	mvwprintw(sub_win, 10, 4, "Semestrů je: %d.", SEMESTRU);
	mvwprintw8(sub_win, 11, 4, L"%-25s",
		   "Zadejte SEMESTR, do kterého předmět patří: ");
	wattroff(sub_win, COLOR_PAIR(SVETLEM));
	wclrtoeol(sub_win);
	box(sub_win, HORZ, VERT);
	wrefresh(sub_win);
	if (0 >= wscanw(sub_win, "%i", &predmet.semestr)) {
	    predmet.semestr = -1;
	}
    }
    while (predmet.semestr < 1 || predmet.semestr > SEMESTRU);


    do {
	wattron(sub_win, COLOR_PAIR(SVETLEM));
	mvwprintw(sub_win, 12, 4, "%s",
		  "Zadejte semestr, ve kterém byl předmět UKONČEN");
	if (!predmet.znamka)
	    mvwprintw(sub_win, 13, 4, "%-25s",
		      "(0= předmět nebyl ukončen): ");
	else
	    mvwprintw(sub_win, 13, 4, "%-25s",
		      "(známkovaný předmět musí být ukončen): ");
	wattroff(sub_win, COLOR_PAIR(SVETLEM));
	wclrtoeol(sub_win);
	box(sub_win, HORZ, VERT);
	wrefresh(sub_win);
	wscanw(sub_win, "%i", &predmet.vsemestru);
    }
    while ((predmet.vsemestru < 0 || predmet.vsemestru > SEMESTRU) ||
	   (!predmet.vsemestru && predmet.znamka));

    noecho();
    mvwprintw8(sub_win, 15, 2, L"%4s %-40s %5s %5s %6s %6s", "kód:",
	       "Název", "sem.", "ukon.", "kredit", "známka");

    mvwprintw8(sub_win, 16, 2, L"%4ls %-40ls %5i %5i %6i %6i", predmet.kod,
	       predmet.nazev, predmet.semestr, predmet.vsemestru,
	       predmet.kreditu, predmet.znamka);

    wint_t wch;
    do {
	wattron(sub_win, COLOR_PAIR(CERVENA));
	mvwprintw(sub_win, 18, 2, "Je zaznam v pořádku? [Ano/Ne/Konec]");
	wattroff(sub_win, COLOR_PAIR(CERVENA));
	wrefresh(sub_win);

	get_wch(&wch);

	switch (wch) {
	case L'n':
	case L'N':
	    goto znovu;
	    break;
	case L'a':
	case L'A':
	    zaznamenej(predmet, dbm_ptr);
	    return;
	    break;
	case L'k':
	case L'K':
	    delwin(sub_win);
	    return;
	    break;
	}
    }
    while (1);

}
